function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

import React from 'react';
import { omit } from 'lodash';
import { Context, injectRescale } from './context';
import { calculateRescale } from './rescale-utils';
import { execChildrenFunctions } from './react-utils';
import DebugGrid from './DebugGrid';
import DebugFrame from './DebugFrame';

export default injectRescale(class SubViz extends React.Component {
  constructor(...args) {
    var _temp;

    return _temp = super(...args), this.innerScales = null, _temp;
  }

  componentWillMount() {
    this.updateScales(this.props);
  }

  componentWillUpdate(nextProps) {
    this.updateScales(nextProps);
  }

  updateScales({ from, to, rescale: outerScales, margin, flipY }) {
    this.innerScales = calculateRescale(outerScales.xy(from), outerScales.xy(to), margin, { flipY });
  }

  render() {
    const _props = this.props,
          { children, debug, margin } = _props,
          otherProps = _objectWithoutProperties(_props, ['children', 'debug', 'margin']);
    const { innerScales } = this;
    const gProps = omit(otherProps, ['rescale', 'from', 'to', 'margin', 'flipY']);

    return React.createElement(
      Context,
      { rescale: innerScales },
      React.createElement(
        'g',
        gProps,
        debug && React.createElement(
          'g',
          null,
          React.createElement(DebugGrid, { color: typeof debug === 'string' ? debug : 'tomato' }),
          React.createElement(DebugFrame, { margin: margin, color: typeof debug === 'string' ? debug : 'tomato' })
        ),
        execChildrenFunctions(children, [innerScales])
      )
    );
  }
});