'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Line = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _utils = require('../utils');

var _context = require('../context');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function scaleXY(scales, _ref) {
  var x = _ref.x,
      y = _ref.y;

  return {
    x: scales.x(x),
    y: scales.y(y)
  };
}

var ZERO = { x: 0, y: 0 };

var Line = (0, _context.inject)('scales')(function (_ref2) {
  var scales = _ref2.scales,
      _ref2$from = _ref2.from,
      from = _ref2$from === undefined ? ZERO : _ref2$from,
      _ref2$to = _ref2.to,
      to = _ref2$to === undefined ? ZERO : _ref2$to,
      _ref2$w = _ref2.w,
      w = _ref2$w === undefined ? 5 : _ref2$w,
      otherProps = _objectWithoutProperties(_ref2, ['scales', 'from', 'to', 'w']);

  (0, _utils.checkCoordinates)([from, to], { component: 'Line', details: otherProps });

  var _scaleXY = scaleXY(scales, from),
      sx1 = _scaleXY.x,
      sy1 = _scaleXY.y;

  var _scaleXY2 = scaleXY(scales, to),
      sx2 = _scaleXY2.x,
      sy2 = _scaleXY2.y;

  otherProps.style = _extends({
    strokeWidth: w,
    strokeLinecap: 'square'
  }, otherProps.style);
  return _react2.default.createElement('line', _extends({ x1: sx1, y1: sy1, x2: sx2, y2: sy2 }, otherProps));
  // return <rect x={sx} y={sy} width={w} height={sx + sy} {...otherProps} />
});
exports.Line = Line;