'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Polyline = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _utils = require('../utils');

var _context = require('../context');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Polyline = (0, _context.inject)('scales')(function (props) {
  var identifier = props.identifier,
      scales = props.scales,
      points = props.points,
      _props$closed = props.closed,
      closed = _props$closed === undefined ? false : _props$closed,
      otherProps = _objectWithoutProperties(props, ['identifier', 'scales', 'points', 'closed']);

  (0, _utils.checkCoordinates)(points, { component: 'Polyline', details: otherProps });
  var scaledPoints = points.map(function (_ref) {
    var x = _ref.x,
        y = _ref.y;
    return { x: scales.x(x), y: scales.y(y) };
  });
  var _scaledPoints$ = scaledPoints[0],
      beginX = _scaledPoints$.x,
      beginY = _scaledPoints$.y;
  var endX = scaledPoints[scaledPoints.length - 1].x;


  var svgPoints = scaledPoints.map(function (_ref2) {
    var x = _ref2.x,
        y = _ref2.y;
    return x + ',' + y;
  }).concat(closed ? endX + ',' + scales.y(0) + ' ' + beginX + ',' + scales.y(0) + ' ' + beginX + ',' + beginY : '').join(' ');

  if (otherProps.onMouseOver) {
    // TODO: Refactor and apply to all other elements.
    var listener = otherProps.onMouseOver;
    otherProps.onMouseOver = function () {
      return listener(identifier);
    };
  }

  otherProps.style = _extends({
    strokeWidth: 5,
    strokeLinecap: 'square'
  }, otherProps.style);

  return _react2.default.createElement('polyline', _extends({ points: svgPoints, y: 0 }, otherProps));
});
exports.Polyline = Polyline;