'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

exports.series = series;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _utils = require('../utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function series(SubComponent) {
  var name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : SubComponent.name + 's';

  var SeriesComponent = function SeriesComponent(_ref) {
    var points = _ref.points,
        _ref$keyFunc = _ref.keyFunc,
        keyFunc = _ref$keyFunc === undefined ? function (_ref2) {
      var x = _ref2.x;
      return x;
    } : _ref$keyFunc,
        otherProps = _objectWithoutProperties(_ref, ['points', 'keyFunc']);

    (0, _utils.checkCoordinates)(points, { component: name, details: otherProps });
    return _react2.default.createElement(
      'g',
      null,
      points.map(function (d) {
        return _react2.default.createElement(SubComponent, _extends({ key: keyFunc(d), x: d.x, y: d.y }, otherProps));
      })
    );
  };
  SeriesComponent.displayName = name;
  return SeriesComponent;
}