'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.calculateScales = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

exports.noop = noop;
exports.normalizeScale = normalizeScale;
exports.denormalizeScale = denormalizeScale;
exports.dimension = dimension;
exports.checkCoordinate = checkCoordinate;
exports.checkCoordinates = checkCoordinates;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function noop() {}

function normalizeScale(_ref, x) {
  var _ref2 = _slicedToArray(_ref, 2),
      xMin = _ref2[0],
      xMax = _ref2[1];

  if (xMax === xMin) return xMin;
  return (x - xMin) / (xMax - xMin);
}

function denormalizeScale(x, _ref3) {
  var _ref4 = _slicedToArray(_ref3, 2),
      xMin = _ref4[0],
      xMax = _ref4[1];

  return x * (xMax - xMin) + xMin;
}

function dimension(ComponentToWrap) {
  return function (_React$Component) {
    _inherits(Dimension, _React$Component);

    function Dimension() {
      var _ref5;

      var _temp, _this, _ret;

      _classCallCheck(this, Dimension);

      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }

      return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref5 = Dimension.__proto__ || Object.getPrototypeOf(Dimension)).call.apply(_ref5, [this].concat(args))), _this), _this.el = null, _this.debouncedUpdate = (0, _lodash.debounce)(function () {
        _this.forceUpdate();
      }, 100), _temp), _possibleConstructorReturn(_this, _ret);
    }

    _createClass(Dimension, [{
      key: 'componentDidMount',
      value: function componentDidMount() {
        var _this2 = this;

        window.addEventListener('resize', this.debouncedUpdate);
        setTimeout(function () {
          _this2.forceUpdate();
        }, 100);
        setTimeout(function () {
          _this2.forceUpdate();
        }, 200); // Two renders, because content resizes.
      }
    }, {
      key: 'componentWillUnmount',
      value: function componentWillUnmount() {
        this.debouncedUpdate.cancel && this.debouncedUpdate.cancel();
        window.removeEventListener('resize', this.debouncedUpdate);
      }
    }, {
      key: 'render',
      value: function render() {
        var _this3 = this;

        var dimensions = this.el ? this.el.getBoundingClientRect() // HEAVY
        : null;

        return _react2.default.createElement(
          'div',
          { style: { width: '100%', height: '100%' }, ref: function ref(el) {
              _this3.el = el;
            } },
          this.el ? _react2.default.createElement(ComponentToWrap, _extends({}, this.props, { dimensions: dimensions })) : _react2.default.createElement('div', null)
        );
      }
    }]);

    return Dimension;
  }(_react2.default.Component);
}

function buildMargin(margin) {
  if (typeof margin === 'number') {
    var m = margin;
    return { top: m, right: m, left: m, bottom: m };
  }

  var vert = margin.vert,
      horiz = margin.horiz;
  var _margin$top = margin.top,
      top = _margin$top === undefined ? vert : _margin$top,
      _margin$bottom = margin.bottom,
      bottom = _margin$bottom === undefined ? vert : _margin$bottom,
      _margin$left = margin.left,
      left = _margin$left === undefined ? horiz : _margin$left,
      _margin$right = margin.right,
      right = _margin$right === undefined ? horiz : _margin$right;

  return { top: top, bottom: bottom, left: left, right: right };
}

function calculateScales(width, height) {
  var margin = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 0;

  var _buildMargin = buildMargin(margin),
      top = _buildMargin.top,
      bottom = _buildMargin.bottom,
      left = _buildMargin.left,
      right = _buildMargin.right;

  var innerWidth = width - (left + right);
  var innerHeight = height - (top + bottom);
  return {
    x: function x(_x2) {
      return left + _x2 * innerWidth;
    },
    y: function y(_y) {
      return top + (1 - _y) * innerHeight;
    },
    inverse: {
      x: function x(ix) {
        return (ix - left) / innerWidth;
      },
      y: function y(iy) {
        return 1 - (iy - top) / innerHeight;
      }
    }
  };
}

exports.calculateScales = calculateScales;
function checkCoordinate(point) {
  var _ref6 = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      _ref6$component = _ref6.component,
      component = _ref6$component === undefined ? 'Unknown' : _ref6$component,
      _ref6$message = _ref6.message,
      message = _ref6$message === undefined ? '' : _ref6$message,
      details = _ref6.details;

  if (![point.x, point.y].every(Number.isFinite)) {
    console.warn('Viz/' + component + ': incorrect coordinate:', { details: details });
    throw new Error('Viz/' + component + ': incorrect coordinate.');
  }
}

function checkCoordinates(points) {
  var info = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  points.forEach(function (p) {
    checkCoordinate(p, info = {});
  });
}