var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from 'react';
import { debounce } from 'lodash';

export default function withDimensions(ComponentToWrap) {
  return class Dimension extends React.Component {
    constructor(...args) {
      var _temp;

      return _temp = super(...args), this.el = null, this.state = { dimensions: null }, this.debouncedUpdate = debounce(() => {
        const dimensions = this.el ? this.el.getBoundingClientRect() // HEAVY
        : null;
        this.setState({ dimensions });
      }, 100), _temp;
    }

    componentDidMount() {
      window.addEventListener('resize', this.debouncedUpdate);
      this.timer = window.setTimeout(this.debouncedUpdate, 400); // Necessary, don't know why
      this.debouncedUpdate();
    }

    componentWillUnmount() {
      window.removeEventListener('resize', this.debouncedUpdate);
      this.timer = window.clearTimeout(this.timer);
      this.debouncedUpdate.cancel && this.debouncedUpdate.cancel();
    }

    render() {
      const { dimensions } = this.state;
      const { width = '100%', height = '100%' } = this.props; // Only to override a dimension

      return React.createElement(
        'div',
        { style: { width, height }, ref: el => {
            this.el = el;
          } },
        dimensions !== null ? React.createElement(ComponentToWrap, _extends({}, this.props, { dimensions: dimensions })) : React.createElement('div', null)
      );
    }
  };
}